﻿Imports System.Drawing

Module Stego
    ' Hide bm_hidden inside bm_visible and return the result.
    Public Function HideImage(ByVal bm_visible As Bitmap, ByVal bm_hidden As Bitmap, ByVal hidden_bits As Integer) As Bitmap
        Dim shift As Integer = (8 - hidden_bits)
        Dim visible_mask As Integer = &HFF << hidden_bits
        Dim hidden_mask As Integer = &HFF >> shift
        Dim bm_combined As New Bitmap(bm_visible.Width, bm_visible.Height)
        For x As Integer = 0 To bm_visible.Width - 1
            For y As Integer = 0 To bm_visible.Height - 1
                Dim clr_visible As Color = bm_visible.GetPixel(x, y)
                Dim clr_hidden As Color = bm_hidden.GetPixel(x, y)
                Dim r As Integer = (clr_visible.R And visible_mask) + ((clr_hidden.R >> shift) And hidden_mask)
                Dim g As Integer = (clr_visible.G And visible_mask) + ((clr_hidden.G >> shift) And hidden_mask)
                Dim b As Integer = (clr_visible.B And visible_mask) + ((clr_hidden.B >> shift) And hidden_mask)
                bm_combined.SetPixel(x, y, Color.FromArgb(255, r, g, b))
            Next y
        Next x
        Return bm_combined
    End Function

    ' Recover a hidden image.
    Public Function RecoverImage(ByVal bm_combined As Bitmap, ByVal hidden_bits As Integer) As Bitmap
        Dim shift As Integer = (8 - hidden_bits)
        Dim hidden_mask As Integer = &HFF >> shift
        Dim bm_hidden As New Bitmap(bm_combined.Width, bm_combined.Height)
        For x As Integer = 0 To bm_combined.Width - 1
            For y As Integer = 0 To bm_combined.Height - 1
                Dim clr_combined As Color = bm_combined.GetPixel(x, y)
                Dim r As Integer = (clr_combined.R And hidden_mask) << shift
                Dim g As Integer = (clr_combined.G And hidden_mask) << shift
                Dim b As Integer = (clr_combined.B And hidden_mask) << shift
                bm_hidden.SetPixel(x, y, Color.FromArgb(255, r, g, b))
            Next y
        Next x
        Return bm_hidden
    End Function
End Module
